/*
 * File : 
 * 	test_prog/testaioli.c
 * 	
 * 	aIOLi is an efficient I/O library for parallel access to remote storages in SMP clusters. 
 * 	Thanks to the kernel features, our framework provides parallel I/O algorithms without 
 * 	inter-processes synchronisation mechanisms as well as a simple interface based on 
 * 	the classic UNIX system calls (creat/open/read/write/close).
 *
 * 	This file is included in the first version of our prototype aIOLi.
 * 	To know which version is currently stable please visit http://aioli.imag.fr
 * 	
 * 	This program is distributed in the hope that it will be useful,
 * 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 * 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Author : 
 * 	Adrien Lebre, adrien.lebre@imag.fr
 *
 * Licence : 
 * 	GPLv2	
 * 	This program is free software; you can redistribute it and/or
 * 	modify it under the terms of the GNU General Public License
 * 	as published by the Free Software Foundation; either version 2
 * 	of the License, or (at your option) any later version.
 * 	
 * 	You should have received a copy of the GNU General Public License
 * 	along with this program; if not, write to the Free Software
 * 	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Contributors :
 * 	BULL Open Source Division - INRIA France
 * 	
 * Created :
 * 	April 2004, the 1st
 *
 * Last Modification(s) : 
 * 	April 2005
 * 	
 * Compilation :
 * 	 see Makefile
 * 	
 * Comments : 
 * This program is just a stupid test to check the behaviour of aioli client part and aioli daemon
 * It reads the ../README file
 * 
 * Changelog :
 * 	look into the CVS log !
 *
*/

// To execute : 
// ./testaioli

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


#define __LIBC_OVERLOAD_ 1
#include "aioli.h"

#define BLKSZ 5
int main(int argc, char *argv[]){
	int desc=-1;
	int result=BLKSZ;
	char buffer[BLKSZ+1];

//open file :
//	desc=open("/tmp/syslog", O_RDONLY);
	desc=open("./README", O_RDONLY);
	if (desc<0){
		perror("open failled");
		exit(1);
	}
//	fprintf(stdout, "Current position for processus %d = %ld\n",getpid(), (long) lseek (desc, (off_t) 0,SEEK_CUR) );

//	sleep(1);
	memset(buffer,0,BLKSZ+1);
	while(result==BLKSZ){
			result=read(desc,buffer,BLKSZ);
			if(result<0){
				perror("Read failed\n");
				exit(1);
			}
				
			buffer[result]='\0';
			fprintf(stdout,"%s",buffer);
	}
	
//	fprintf(stdout, "\nClose file %d",desc );
	close(desc);
	return 1;
}

